unit LoadRule;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

const
  InteractingStatesDefault = 'TB0,TS1,B1;00002030,B2;00000000,B3;02030000,' +
    'B4;00020000,B5;00200010,B6;00101000,B7;00020003,B8;02000300,S1;00000000,' +
    'S2;00010020,S3;10000000,S4;20000000,S5;00200000,S6;20100000,S7;00022000,' +
    'S8;00200001';
  GeneralBinaryDefault = 'C16,NM,S4b3abaabbaa4bababbab6abbaab3abab3abb5abab' +
    '5ab3ab4abb10abababbaa3baababbababb6abaabaabbabbaba3b4abaababaabbababaabb' +
    'abbaabb3abb3aba3b3abab3abba3b3a3b5ab7a3babb7abbaab3ab4abbababba3b3abbaab' +
    'baa3baba,B6abb6abaa3babbab5ab5aba3bab7abb4a3baabab6a3babababab7ababababb' +
    'a3baabb6abb4abab8ababab3a4baabaabaabaab9ab5abaa4baaba3babaabbaa3babb4abb' +
    'a4bababb3ab5abb3abaab3a4baba4b7abbaabba';
  WeightedGenerationsDefault = 'C4,SW0;1;0;0,PW1;1;1;1;0;1;1;1;1,RS3;4;5,RB2';

type
  TLoadRuleDialog = class(TForm)
    GeneralBinaryRadioButton: TRadioButton;
    InteractingStatesRadioButton: TRadioButton;
    WeightedGenerationsRadioButton: TRadioButton;
    RuleStringLabel: TLabel;
    RuleStringEdit: TEdit;
    OkButton: TButton;
    CancelButton: TButton;
    procedure FormShow(Sender: TObject);
    procedure OkButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
  private
  public
  end;

var
  LoadRuleDialog: TLoadRuleDialog;

implementation

{$R *.DFM}

procedure TLoadRuleDialog.FormShow(Sender: TObject);
begin
  if GeneralBinaryRadioButton.Checked then
    RuleStringEdit.Text := GeneralBinaryDefault
  else if InteractingStatesRadioButton.Checked then
    RuleStringEdit.Text := InteractingStatesDefault
  else if WeightedGenerationsRadioButton.Checked then
    RuleStringEdit.Text := WeightedGenerationsDefault;
end;

procedure TLoadRuleDialog.OkButtonClick(Sender: TObject);
begin
  ModalResult := mrOk;
end;

procedure TLoadRuleDialog.CancelButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

end.

