unit Options;

interface

uses
  Windows, Messages, SysUtils, Classes, GR32, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TOptionsDialog = class(TForm)
    ColorGroupBox: TGroupBox;
    ColorLabelTop: TLabel;
    State0Color: TPanel;
    State1Color: TPanel;
    State2Color: TPanel;
    State3Color: TPanel;
    State4Color: TPanel;
    State5Color: TPanel;
    State6Color: TPanel;
    State7Color: TPanel;
    GridColor: TPanel;
    ColorLabelBottom: TLabel;
    State8Color: TPanel;
    State9Color: TPanel;
    State10Color: TPanel;
    State11Color: TPanel;
    State12Color: TPanel;
    State13Color: TPanel;
    State14Color: TPanel;
    State15Color: TPanel;
    SelectorColor: TPanel;
    ColorDialog: TColorDialog;
    GridSizeGroupBox: TGroupBox;
    GridSizeSelector: TComboBox;
    StepSizeGroupBox: TGroupBox;
    StepSizeEdit: TEdit;
    RandomDensityGroupBox: TGroupBox;
    RandomDensitySelector: TComboBox;
    NewRuleLabel: TLabel;
    WeightedGenerationsGroupBox: TGroupBox;
    WeightedGenerationsStateWeights: TCheckBox;
    WeightedGenerationsBirth: TCheckBox;
    WeightedGenerationsSurvival: TCheckBox;
    InteractingStatesGroupBox: TGroupBox;
    InteractingStatesBirth: TCheckBox;
    InteractingStatesSurvival: TCheckBox;
    GeneralBinaryGroupBox: TGroupBox;
    GeneralBinaryDensitySelector: TComboBox;
    GeneralBinaryDensityLabel: TLabel;
    GeneralBinaryIsotropic: TCheckBox;
    GeneralBinaryVariant: TCheckBox;
    GeneralBinaryVariantSetButton: TButton;
    OKButton: TButton;
    procedure FormCreate(Sender: TObject);
    procedure State0ColorClick(Sender: TObject);
    procedure State1ColorClick(Sender: TObject);
    procedure State2ColorClick(Sender: TObject);
    procedure State3ColorClick(Sender: TObject);
    procedure State4ColorClick(Sender: TObject);
    procedure State5ColorClick(Sender: TObject);
    procedure State6ColorClick(Sender: TObject);
    procedure State7ColorClick(Sender: TObject);
    procedure GridColorClick(Sender: TObject);
    procedure State8ColorClick(Sender: TObject);
    procedure State9ColorClick(Sender: TObject);
    procedure State10ColorClick(Sender: TObject);
    procedure State11ColorClick(Sender: TObject);
    procedure State12ColorClick(Sender: TObject);
    procedure State13ColorClick(Sender: TObject);
    procedure State14ColorClick(Sender: TObject);
    procedure State15ColorClick(Sender: TObject);
    procedure SelectorColorClick(Sender: TObject);
    procedure StepSizeEditChange(Sender: TObject);
    procedure GeneralBinaryVariantSetButtonClick(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
  private
  public
  end;

var
  OptionsDialog: TOptionsDialog;
  Error: Boolean;

implementation

uses
  Display, SquareCA, StateSelector;

{$R *.DFM}

procedure TOptionsDialog.FormCreate(Sender: TObject);
begin
  if GridSizeSelector.ItemIndex = -1 then
    GridSizeSelector.ItemIndex := 7;
  if RandomDensitySelector.ItemIndex = -1 then
    RandomDensitySelector.ItemIndex := 9;
  if GeneralBinaryDensitySelector.ItemIndex = -1 then
    GeneralBinaryDensitySelector.ItemIndex := 1;        
  Colors[0] := Color32(State0Color.Color);
  Colors[1] := Color32(State1Color.Color);
  Colors[2] := Color32(State2Color.Color);
  Colors[3] := Color32(State3Color.Color);
  Colors[4] := Color32(State4Color.Color);
  Colors[5] := Color32(State5Color.Color);
  Colors[6] := Color32(State6Color.Color);
  Colors[7] := Color32(State7Color.Color);
  SquareCA.GridColor := Color32(GridColor.Color);
  Colors[8] := Color32(State8Color.Color);
  Colors[9] := Color32(State9Color.Color);
  Colors[10] := Color32(State10Color.Color);
  Colors[11] := Color32(State11Color.Color);
  Colors[12] := Color32(State12Color.Color);
  Colors[13] := Color32(State13Color.Color);
  Colors[14] := Color32(State14Color.Color);
  Colors[15] := Color32(State15Color.Color);
  SquareCA.SelectorColor := Color32(SelectorColor.Color);
end;

procedure TOptionsDialog.State0ColorClick(Sender: TObject);
begin
  if ColorDialog.Execute then
  begin
    State0Color.Color := ColorDialog.Color;
    Colors[0] := Color32(ColorDialog.Color);
  end;
end;

procedure TOptionsDialog.State1ColorClick(Sender: TObject);
begin
  if ColorDialog.Execute then
  begin
    State1Color.Color := ColorDialog.Color;
    Colors[1] := Color32(ColorDialog.Color);
  end;
end;

procedure TOptionsDialog.State2ColorClick(Sender: TObject);
begin
  if ColorDialog.Execute then
  begin
    State2Color.Color := ColorDialog.Color;
    Colors[2] := Color32(ColorDialog.Color);
  end;
end;

procedure TOptionsDialog.State3ColorClick(Sender: TObject);
begin
  if ColorDialog.Execute then
  begin
    State3Color.Color := ColorDialog.Color;
    Colors[3] := Color32(ColorDialog.Color);
  end;
end;

procedure TOptionsDialog.State4ColorClick(Sender: TObject);
begin
  if ColorDialog.Execute then
  begin
    State4Color.Color := ColorDialog.Color;
    Colors[4] := Color32(ColorDialog.Color);
  end;
end;

procedure TOptionsDialog.State5ColorClick(Sender: TObject);
begin
  if ColorDialog.Execute then
  begin
    State5Color.Color := ColorDialog.Color;
    Colors[5] := Color32(ColorDialog.Color);
  end;
end;

procedure TOptionsDialog.State6ColorClick(Sender: TObject);
begin
  if ColorDialog.Execute then
  begin
    State6Color.Color := ColorDialog.Color;
    Colors[6] := Color32(ColorDialog.Color);
  end;
end;

procedure TOptionsDialog.State7ColorClick(Sender: TObject);
begin
  if ColorDialog.Execute then
  begin
    State7Color.Color := ColorDialog.Color;
    Colors[7] := Color32(ColorDialog.Color);
  end;
end;

procedure TOptionsDialog.GridColorClick(Sender: TObject);
begin
  if ColorDialog.Execute then
  begin
    GridColor.Color := ColorDialog.Color;
    SquareCA.GridColor := Color32(GridColor.Color);
  end;
end;

procedure TOptionsDialog.State8ColorClick(Sender: TObject);
begin
  if ColorDialog.Execute then
  begin
    State8Color.Color := ColorDialog.Color;
    Colors[8] := Color32(ColorDialog.Color);
  end;
end;

procedure TOptionsDialog.State9ColorClick(Sender: TObject);
begin
  if ColorDialog.Execute then
  begin
    State9Color.Color := ColorDialog.Color;
    Colors[9] := Color32(ColorDialog.Color);
  end;
end;

procedure TOptionsDialog.State10ColorClick(Sender: TObject);
begin
  if ColorDialog.Execute then
  begin
    State10Color.Color := ColorDialog.Color;
    Colors[10] := Color32(ColorDialog.Color);
  end;
end;

procedure TOptionsDialog.State11ColorClick(Sender: TObject);
begin
  if ColorDialog.Execute then
  begin
    State11Color.Color := ColorDialog.Color;
    Colors[11] := Color32(ColorDialog.Color);
  end;
end;

procedure TOptionsDialog.State12ColorClick(Sender: TObject);
begin
  if ColorDialog.Execute then
  begin
    State12Color.Color := ColorDialog.Color;
    Colors[12] := Color32(ColorDialog.Color);
  end;
end;

procedure TOptionsDialog.State13ColorClick(Sender: TObject);
begin
  if ColorDialog.Execute then
  begin
    State13Color.Color := ColorDialog.Color;
    Colors[13] := Color32(ColorDialog.Color);
  end;
end;

procedure TOptionsDialog.State14ColorClick(Sender: TObject);
begin
  if ColorDialog.Execute then
  begin
    State14Color.Color := ColorDialog.Color;
    Colors[14] := Color32(ColorDialog.Color);
  end;
end;

procedure TOptionsDialog.State15ColorClick(Sender: TObject);
begin
  if ColorDialog.Execute then
  begin
    State15Color.Color := ColorDialog.Color;
    Colors[15] := Color32(ColorDialog.Color);
  end;
end;

procedure TOptionsDialog.SelectorColorClick(Sender: TObject);
begin
  if ColorDialog.Execute then
  begin
    SelectorColor.Color := ColorDialog.Color;
    SquareCA.SelectorColor := Color32(SelectorColor.Color);
  end;
end;

procedure TOptionsDialog.StepSizeEditChange(Sender: TObject);
var
  S: String;
  V: Integer;
begin
  Error := False;
  S := StepSizeEdit.Text;
  if S = '' then
    S := '1';
  try
    V := StrToInt(S);
    if (V < 1) or (V > 10000) then
      raise Exception.Create('');
  except
    Error := True;
    MessageDlg('Step Size: Integer 1 to 10000', mtError, [mbRetry], 0);
  end;
end;

procedure TOptionsDialog.GeneralBinaryVariantSetButtonClick(Sender: TObject);
begin
  GeneralBinaryBaseRule := GeneralBinaryRuleString;
end;

procedure TOptionsDialog.OKButtonClick(Sender: TObject);
begin
  if Error then
    Exit;
  ModalResult := mrOk;
end;

end.

