unit SelectionControl;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TSelectionControlDialog = class(TForm)
    SelectionControlGroupBox: TGroupBox;
    ClearInsideButton: TButton;
    ClearInsideLabel: TLabel;
    ClearOutsideButton: TButton;
    ClearOutsideLabel: TLabel;
    FlipXButton: TButton;
    FlipXLabel: TLabel;
    FlipYButton: TButton;
    FlipYLabel: TLabel;
    RotateClockwiseButton: TButton;
    RotateClockwiseLabel: TLabel;
    RotateAntiClockwiseButton: TButton;
    RotateAntiClockwiseLabel: TLabel;
    SelectAllButton: TButton;
    SelectAllLabel: TLabel;
    SelectSquareButton: TButton;
    SelectSquareLabel: TLabel;
    CenterButton: TButton;
    CenterLabel: TLabel;
    SaveButton: TButton;
    SaveLabel: TLabel;
    RandomButton: TButton;
    RandomLabel: TLabel;
    CopyRadioButton: TRadioButton;
    MoveRadioButton: TRadioButton;
    procedure ClearInsideButtonClick(Sender: TObject);
    procedure ClearOutsideButtonClick(Sender: TObject);
    procedure FlipXButtonClick(Sender: TObject);
    procedure FlipYButtonClick(Sender: TObject);
    procedure RotateClockwiseButtonClick(Sender: TObject);
    procedure RotateAntiClockwiseButtonClick(Sender: TObject);
    procedure SelectAllButtonClick(Sender: TObject);
    procedure SelectSquareButtonClick(Sender: TObject);
    procedure CenterButtonClick(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure RandomButtonClick(Sender: TObject);
  private
  public
  end;

var
  SelectionControlDialog: TSelectionControlDialog;

implementation

uses
  Display, SquareCA;

{$R *.DFM}

procedure TSelectionControlDialog.ClearInsideButtonClick(Sender: TObject);
begin
  if Selected <> GroupSelected then
    Exit;
  ClearInside;
  DrawCells;
end;

procedure TSelectionControlDialog.ClearOutsideButtonClick(Sender: TObject);
begin
  if Selected <> GroupSelected then
    Exit;
  ClearOutside;
  DrawCells;
end;

procedure TSelectionControlDialog.FlipXButtonClick(Sender: TObject);
begin
  if Selected <> GroupSelected then
    Exit;
  FlipX;
  DrawCells;
end;

procedure TSelectionControlDialog.FlipYButtonClick(Sender: TObject);
begin
  if Selected <> GroupSelected then
    Exit;
  FlipY;
  DrawCells;
end;

procedure TSelectionControlDialog.RotateClockwiseButtonClick(
  Sender: TObject);
begin
  if Selected <> GroupSelected then
    Exit;
  RotateClockwise;
  DrawCells;
end;

procedure TSelectionControlDialog.RotateAntiClockwiseButtonClick(
  Sender: TObject);
begin
  if Selected <> GroupSelected then
    Exit;
  RotateAntiClockwise;
  DrawCells;
end;

procedure TSelectionControlDialog.SelectAllButtonClick(Sender: TObject);
begin
  SelectAll;
  DrawCells;
end;

procedure TSelectionControlDialog.SelectSquareButtonClick(Sender: TObject);
begin
  SelectSquare;
  DrawCells;
end;

procedure TSelectionControlDialog.CenterButtonClick(Sender: TObject);
begin
  if Selected <> GroupSelected then
    Exit;
  Center;
  Selected := None;
  DrawCells;
  SelectAll;
  DrawCells;
end;

procedure TSelectionControlDialog.SaveButtonClick(Sender: TObject);
begin
  if Selected <> GroupSelected then
    Exit;
  with DisplayForm do
  begin
    SaveDialog.InitialDir := 'C:\New Rules';
    if SaveDialog.Execute then
      SavePattern(SaveDialog.FileName);
  end;
end;

procedure TSelectionControlDialog.RandomButtonClick(Sender: TObject);
begin
  if Selected <> GroupSelected then
    Exit;
  RandomSelection;
  DrawCells;
end;

end.

