unit WeightedGenerations;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

const
  ArraySize = 30;

type
  TWeightedGenerationsDialog = class(TForm)
    NumberStatesGroup: TGroupBox;
    NumberStatesEdit: TEdit;
    NumberStatesUpDown: TUpDown;
    SurvivalGroup: TGroupBox;
    SurvivalDisplay: TListBox;
    SurvivalAddEdit: TEdit;
    SurvivalAddButton: TButton;
    SurvivalDeleteButton: TButton;
    SurvivalClearButton: TButton;
    BirthGroup: TGroupBox;
    BirthDisplay: TListBox;
    BirthAddEdit: TEdit;
    BirthAddButton: TButton;
    BirthDeleteButton: TButton;
    BirthClearButton: TButton;
    StateWeightsGroup: TGroupBox;
    LabelS0: TLabel;
    EditS0: TEdit;
    UpDownS0: TUpDown;
    LabelS1: TLabel;
    EditS1: TEdit;
    UpDownS1: TUpDown;
    LabelS2: TLabel;
    EditS2: TEdit;
    UpDownS2: TUpDown;
    LabelS3: TLabel;
    EditS3: TEdit;
    UpDownS3: TUpDown;
    LabelS4: TLabel;
    EditS4: TEdit;
    UpDownS4: TUpDown;
    LabelS5: TLabel;
    EditS5: TEdit;
    UpDownS5: TUpDown;
    LabelS6: TLabel;
    EditS6: TEdit;
    UpDownS6: TUpDown;
    LabelS7: TLabel;
    EditS7: TEdit;
    UpDownS7: TUpDown;
    LabelS8: TLabel;
    EditS8: TEdit;
    UpDownS8: TUpDown;
    LabelS9: TLabel;
    EditS9: TEdit;
    UpDownS9: TUpDown;
    LabelS10: TLabel;
    EditS10: TEdit;
    UpDownS10: TUpDown;
    LabelS11: TLabel;
    EditS11: TEdit;
    UpDownS11: TUpDown;
    LabelS12: TLabel;
    EditS12: TEdit;
    UpDownS12: TUpDown;
    LabelS13: TLabel;
    EditS13: TEdit;
    UpDownS13: TUpDown;
    LabelS14: TLabel;
    EditS14: TEdit;
    UpDownS14: TUpDown;
    LabelS15: TLabel;
    EditS15: TEdit;
    UpDownS15: TUpDown;
    PositionWeightsGroup: TGroupBox;
    LabelPNW: TLabel;
    EditPNW: TEdit;
    UpDownPNW: TUpDown;
    LabelPN: TLabel;
    EditPN: TEdit;
    UpDownPN: TUpDown;
    LabelPNE: TLabel;
    EditPNE: TEdit;
    UpDownPNE: TUpDown;
    LabelPW: TLabel;
    EditPW: TEdit;
    UpDownPW: TUpDown;
    LabelPC: TLabel;
    EditPC: TEdit;
    UpDownPC: TUpDown;
    LabelPE: TLabel;
    EditPE: TEdit;
    UpDownPE: TUpDown;
    LabelSW: TLabel;
    EditPSW: TEdit;
    UpDownPSW: TUpDown;
    LabelPS: TLabel;
    EditPS: TEdit;
    UpDownPS: TUpDown;
    LabelPSE: TLabel;
    EditPSE: TEdit;
    UpDownPSE: TUpDown;
    RuleText: TEdit;
    OkButton: TButton;
    CancelButton: TButton;
    procedure FormShow(Sender: TObject);
    procedure BirthAddButtonClick(Sender: TObject);
    procedure BirthDeleteButtonClick(Sender: TObject);
    procedure BirthClearButtonClick(Sender: TObject);
    procedure SurvivalAddButtonClick(Sender: TObject);
    procedure SurvivalDeleteButtonClick(Sender: TObject);
    procedure SurvivalClearButtonClick(Sender: TObject);
    procedure Apply();
    procedure GenerateNewRule;
    procedure OkButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure DisplayRuleText(Sender: TObject);
  private
  public
  end;
  
  StateWeightsType = Array[0..15] of Integer;
  PositionWeightsType = Array[0..8] of Integer;
  ListType = Array[1..ArraySize] of Integer;

procedure SetEdit(Edit: TEdit; Value: Integer);
procedure InitRuleFromString(S: String);
function GetRuleAsString: String;

var
  WeightedGenerationsDialog: TWeightedGenerationsDialog;
  NumberOfStates: Integer;
  StateWeights: StateWeightsType;
  PositionWeights: PositionWeightsType;
  BirthCount: Integer;
  BirthList: ListType;
  SurvivalCount: Integer;
  SurvivalList: ListType;

implementation

uses
  Options;

{$R *.DFM}

procedure SetEdit(Edit: TEdit; Value: Integer);
begin
  Edit.ReadOnly := False;
  Edit.Text := IntToStr(Value);
  Edit.ReadOnly := True
end;

procedure TWeightedGenerationsDialog.FormShow(Sender: TObject);
var
  I: Integer;
begin
  SetEdit(NumberStatesEdit, NumberOfStates);
  SetEdit(EditS0,  StateWeights[ 0]);
  SetEdit(EditS1,  StateWeights[ 1]);
  SetEdit(EditS2,  StateWeights[ 2]);
  SetEdit(EditS3,  StateWeights[ 3]);
  SetEdit(EditS4,  StateWeights[ 4]);
  SetEdit(EditS5,  StateWeights[ 5]);
  SetEdit(EditS6,  StateWeights[ 6]);
  SetEdit(EditS7,  StateWeights[ 7]);
  SetEdit(EditS8,  StateWeights[ 8]);
  SetEdit(EditS9,  StateWeights[ 9]);
  SetEdit(EditS10, StateWeights[10]);
  SetEdit(EditS11, StateWeights[11]);
  SetEdit(EditS12, StateWeights[12]);
  SetEdit(EditS13, StateWeights[13]);
  SetEdit(EditS14, StateWeights[14]);
  SetEdit(EditS15, StateWeights[15]);
  SetEdit(EditPNW, PositionWeights[0]);
  SetEdit(EditPN,  PositionWeights[1]);
  SetEdit(EditPNE, PositionWeights[2]);
  SetEdit(EditPW,  PositionWeights[3]);
  SetEdit(EditPC,  PositionWeights[4]);
  SetEdit(EditPE,  PositionWeights[5]);
  SetEdit(EditPSW, PositionWeights[6]);
  SetEdit(EditPS,  PositionWeights[7]);
  SetEdit(EditPSE, PositionWeights[8]);
  BirthAddEdit.Text := '';
  BirthDisplay.Clear;
  for I := 1 to BirthCount do
    BirthDisplay.Items.Strings[I - 1] := IntToStr(BirthList[I]);
  SurvivalAddEdit.Text := '';
  SurvivalDisplay.Clear;
  for I := 1 to SurvivalCount do
    SurvivalDisplay.Items.Strings[I - 1] := IntToStr(SurvivalList[I]);
  DisplayRuleText(Nil)
end;

procedure TWeightedGenerationsDialog.BirthAddButtonClick(Sender: TObject);
var
  NewValue, Value, ErrorCode, I, N: Integer;
begin
  Val(BirthAddEdit.Text, NewValue, ErrorCode);
  if (ErrorCode <> 0) or (NewValue < 0) then
    MessageDlg('Error: must be a positive integer', mtError, [mbOK], 0)
  else
  begin
    N := BirthDisplay.Items.Count - 1;
    if (N < 0) or (StrToInt(BirthDisplay.Items.Strings[N]) < NewValue) then
      BirthDisplay.Items.Add(BirthAddEdit.Text)
    else
      for I := 0 to N do
      begin
        Value := StrToInt(BirthDisplay.Items.Strings[I]);
        if NewValue = Value then
          Break;
        if NewValue < Value then
        begin
          BirthDisplay.Items.Insert(I, BirthAddEdit.Text);
          Break
        end
      end
  end;
  BirthAddEdit.Text := '';
  DisplayRuleText(Nil)
end;

procedure TWeightedGenerationsDialog.BirthDeleteButtonClick(Sender: TObject);
begin
  BirthDisplay.Items.Delete(BirthDisplay.ItemIndex);
  DisplayRuleText(Nil)
end;

procedure TWeightedGenerationsDialog.BirthClearButtonClick(Sender: TObject);
begin
  BirthDisplay.Clear;
  BirthAddEdit.Clear;
  DisplayRuleText(Nil)
end;

procedure TWeightedGenerationsDialog.SurvivalAddButtonClick(Sender: TObject);
var
  NewValue, Value, ErrorCode, I, N: Integer;
begin
  Val(SurvivalAddEdit.Text, NewValue, ErrorCode);
  if (ErrorCode <> 0) or (NewValue < 0) then
    MessageDlg('Error: must be a positive integer', mtError, [mbOK], 0)
  else
  begin
    N := SurvivalDisplay.Items.Count - 1;
    if (N < 0) or (StrToInt(SurvivalDisplay.Items.Strings[N]) < NewValue) then
      SurvivalDisplay.Items.Add(SurvivalAddEdit.Text)
    else
      for I := 0 to N do
      begin
        Value := StrToInt(SurvivalDisplay.Items.Strings[I]);
        if NewValue = Value then
          Break;
        if NewValue < Value then
        begin
          SurvivalDisplay.Items.Insert(I, SurvivalAddEdit.Text);
          Break
        end
      end
  end;
  SurvivalAddEdit.Text := '';
  DisplayRuleText(Nil)
end;

procedure TWeightedGenerationsDialog.SurvivalDeleteButtonClick
                                                              (Sender: TObject);
begin
  SurvivalDisplay.Items.Delete(SurvivalDisplay.ItemIndex);
  DisplayRuleText(Nil)
end;

procedure TWeightedGenerationsDialog.SurvivalClearButtonClick(Sender: TObject);
begin
  SurvivalDisplay.Clear;
  SurvivalAddEdit.Clear;
  DisplayRuleText(Nil)
end;

procedure TWeightedGenerationsDialog.Apply();
var
    I: Integer;
begin
  NumberOfStates := StrToInt(NumberStatesEdit.Text);
  StateWeights[ 0] := StrToInt(EditS0.Text);
  StateWeights[ 1] := StrToInt(EditS1.Text);
  StateWeights[ 2] := StrToInt(EditS2.Text);
  StateWeights[ 3] := StrToInt(EditS3.Text);
  StateWeights[ 4] := StrToInt(EditS4.Text);
  StateWeights[ 5] := StrToInt(EditS5.Text);
  StateWeights[ 6] := StrToInt(EditS6.Text);
  StateWeights[ 7] := StrToInt(EditS7.Text);
  StateWeights[ 8] := StrToInt(EditS8.Text);
  StateWeights[ 9] := StrToInt(EditS9.Text);
  StateWeights[10] := StrToInt(EditS10.Text);
  StateWeights[11] := StrToInt(EditS11.Text);
  StateWeights[12] := StrToInt(EditS12.Text);
  StateWeights[13] := StrToInt(EditS13.Text);
  StateWeights[14] := StrToInt(EditS14.Text);
  StateWeights[15] := StrToInt(EditS15.Text);
  PositionWeights[0] := StrToInt(EditPNW.Text);
  PositionWeights[1] := StrToInt(EditPN.Text);
  PositionWeights[2] := StrToInt(EditPNE.Text);
  PositionWeights[3] := StrToInt(EditPW.Text);
  PositionWeights[4] := StrToInt(EditPC.Text);
  PositionWeights[5] := StrToInt(EditPE.Text);
  PositionWeights[6] := StrToInt(EditPSW.Text);
  PositionWeights[7] := StrToInt(EditPS.Text);
  PositionWeights[8] := StrToInt(EditPSE.Text);
  SurvivalCount := SurvivalDisplay.Items.Count;
  for I := 1 to SurvivalCount do
    SurvivalList[I] := StrToInt(SurvivalDisplay.Items.Strings[I - 1]);
  BirthCount := BirthDisplay.Items.Count;
  for I := 1 to BirthCount do
    BirthList[I] := StrToInt(BirthDisplay.Items.Strings[I - 1])
end;

procedure TWeightedGenerationsDialog.GenerateNewRule;
var
  I, B, E, R: Integer;

procedure SetStateWeight(N, V: Integer);
begin
  case N of
  1:
    EditS1.Text := IntToStr(V);
  2:
    EditS2.Text := IntToStr(V);
  3:
    EditS3.Text := IntToStr(V);
  4:
    EditS4.Text := IntToStr(V);
  5:
    EditS5.Text := IntToStr(V);
  6:
    EditS6.Text := IntToStr(V);
  7:
    EditS7.Text := IntToStr(V);
  8:
    EditS8.Text := IntToStr(V);
  9:
    EditS9.Text := IntToStr(V);
  10:
    EditS10.Text := IntToStr(V);
  11:
    EditS11.Text := IntToStr(V);
  12:
    EditS12.Text := IntToStr(V);
  13:
    EditS13.Text := IntToStr(V);
  14:
    EditS14.Text := IntToStr(V);
  15:
    EditS15.Text := IntToStr(V);
  end;
end;

begin
  FormShow(Nil);
  Randomize;
  if OptionsDialog.WeightedGenerationsBirth.Checked then
  begin
    BirthClearButtonClick(nil);
    B := Random(5) + 1;
    E := B + Random(5);
    R := Random(256);
    for I := B to E do
    begin
      if Odd(R) then
      begin
        BirthAddEdit.Text := IntToStr(I);
        BirthAddButtonClick(nil);
      end;
      R := R shr 1;
    end;
  end;
  if OptionsDialog.WeightedGenerationsSurvival.Checked then
  begin
    SurvivalClearButtonClick(nil);
    B := Random(5) + 1;
    E := B + Random(5);
    R := Random(256);
    for I := B to E do
    begin
      if Odd(R) then
      begin
        SurvivalAddEdit.Text := IntToStr(I);
        SurvivalAddButtonClick(nil);
      end;
      R := R shr 1;
    end;
  end;
  if OptionsDialog.WeightedGenerationsStateWeights.Checked then
  begin
    for I := 2 to NumberOfStates do
      SetStateWeight(I - 1, Random(21) - 10);
  end;
  Apply;
end;

procedure TWeightedGenerationsDialog.OkButtonClick(Sender: TObject);
begin
  Apply;
  ModalResult := mrOK;
end;

procedure TWeightedGenerationsDialog.CancelButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TWeightedGenerationsDialog.DisplayRuleText(Sender: TObject);
var
  SaveNumberOfStates: Integer;
  SaveStateWeights: StateWeightsType;
  SavePositionWeights: PositionWeightsType;
  SaveBirthCount: Integer;
  SaveBirthList: ListType;
  SaveSurvivalCount: Integer;
  SaveSurvivalList: ListType;
begin
  SaveNumberOfStates := NumberOfStates;
  SaveStateWeights := StateWeights;
  SavePositionWeights := PositionWeights;
  SaveBirthCount := BirthCount;
  SaveBirthList := BirthList;
  SaveSurvivalCount := SurvivalCount;
  SaveSurvivalList := SurvivalList;
  Apply();
  RuleText.Text := GetRuleAsString();
  NumberOfStates := SaveNumberOfStates;
  StateWeights := SaveStateWeights;
  PositionWeights := SavePositionWeights;
  BirthCount := SaveBirthCount;
  BirthList := SaveBirthList;
  SurvivalCount := SaveSurvivalCount;
  SurvivalList := SaveSurvivalList
end;

function BoundInt(iMin: Integer; var iVal: Integer; iMax: Integer): Integer;
var
  iTmp: Integer;
begin
  if iMin > iMax then
  begin
    iTmp := iMin;
    iMin := iMax;
    iMax := iTmp;
  end;
  if iVal < iMin then iVal := iMin;
  if iVal > iMax then iVal := iMax;
  BoundInt := iVal;
end;

procedure InitRuleFromString(S: String);
var
  I, P: Integer;

function GetValue: Integer;
var
  N, V: Integer;
begin
  V := 0;
  if S[P] = '-' then
  begin
    N := -1;
    Inc(P);
  end
  else
    N := 1;
  while (S[P] >= '0') and (S[P] <= '9') do
  begin
    V := V * 10 + StrToInt(S[P]);
    Inc(P);
  end;
  Result := N * V;
end;

begin
  NumberOfStates := 2;
  for I := 0 to 15 do
    StateWeights[I] := 0;
  StateWeights[1] := 1;
  SurvivalCount := 0;
  for I := 1 to ArraySize do
    SurvivalList[I] := 0;
  BirthCount := 0;
  for I := 1 to ArraySize do
    BirthList[I] := 0;
  S := S + ',';
  P := 2;
  NumberOfStates := GetValue;
  Inc(P, 3);
  for I := 0 to NumberOfStates - 1 do
  begin
    StateWeights[I] := GetValue;
    Inc(P);
  end;
  Inc(P, 2);
  for I := 0 to 8 do
  begin
    PositionWeights[I] := GetValue;
    Inc(P);
  end;
  Inc(P, 2);
  SurvivalCount := 0;
  if S[P] <> ',' then
    for I := 1 to ArraySize do
    begin
      SurvivalList[I] := GetValue;
      Inc(SurvivalCount);
      if S[P] = ',' then
        Break;
      Inc(P);
    end;
  Inc(P, 3);
  BirthCount := 0;
  if S[P] <> ',' then
  for I := 1 to ArraySize do
    begin
      BirthList[I] := GetValue;
      Inc(BirthCount);
      if S[P] = ',' then
        Break;
      Inc(P);
    end;
end;

function GetRuleAsString: String;
var
  I: Integer;
  S: String;
begin
  S := 'C' + IntToStr(NumberOfStates);
  S := S + ',SW';
  for I := 0 to NumberOfStates - 2 do
    S := S + IntToStr(StateWeights[I]) + ';';
  S := S + IntToStr(StateWeights[NumberOfStates - 1]);
  S := S + ',PW';
  for I := 0 to 7 do
    S := S + IntToStr(PositionWeights[I]) + ';';
  S := S + IntToStr(PositionWeights[8]);
  S := S + ',RS';
  for I := 1 to SurvivalCount do
  begin
    S := S + IntToStr(SurvivalList[I]);
    if I < SurvivalCount then
      S := S + ';'
  end;
  S := S + ',RB';
  for I := 1 to BirthCount do
  begin
    S := S + IntToStr(BirthList[I]);
    if I < BirthCount then
      S := S + ';'
  end;
  Result := S;
end;

end.
